"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.install = void 0;
const exec_1 = __importDefault(require("@simplyhexagonal/exec"));
const path_1 = __importDefault(require("path"));
const fs_extra_1 = __importDefault(require("fs-extra"));
function install({ directory }) {
    return __awaiter(this, void 0, void 0, function* () {
        if (yield fs_extra_1.default.pathExists(directory)) {
            throw new Error(`The directory ${directory} already exists`);
        }
        const { execPromise: gitInitExecPromise } = (0, exec_1.default)(`git clone https://github.com/deep-foundation/typescript-npm-package-template.git ${directory}`);
        const gitInitResult = yield gitInitExecPromise;
        if (gitInitResult.exitCode !== 0) {
            throw new Error(gitInitResult.stderrOutput);
        }
        console.log(gitInitResult.stdoutOutput);
        yield fs_extra_1.default.remove(path_1.default.join(directory, '.git'));
    });
}
exports.install = install;
