"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.setup = void 0;
const fs_extra_1 = __importDefault(require("fs-extra"));
const glob_1 = require("glob");
function setup({ packageName, description, repositoryUrl, path, }) {
    return __awaiter(this, void 0, void 0, function* () {
        const replacementDictionary = {
            '<PACKAGE_NAME>': packageName,
            '<DESCRIPTION>': description,
            '<REPOSITORY_URL>': repositoryUrl,
        };
        let files = yield (0, glob_1.glob)(`./${path}/**/*`, {
            ignore: ['**/node_modules/**/*'],
            absolute: true,
        });
        files = yield Promise.all(files.filter((file) => fs_extra_1.default.lstatSync(file).isFile()));
        const promises = [];
        for (const file of files) {
            const promise = new Promise(() => __awaiter(this, void 0, void 0, function* () {
                let fileContent = yield fs_extra_1.default.readFile(file, 'utf-8');
                for (const [key, value] of Object.entries(replacementDictionary)) {
                    fileContent = fileContent.replace(key, value);
                }
                yield fs_extra_1.default.writeFile(file, fileContent);
            }));
            promises.push(promise);
        }
        yield Promise.all(promises);
    });
}
exports.setup = setup;
